<template>
    <div :style="{ 'width': width, 'height': height }">
        <slot></slot>
        <svg height="100%" width="100%">
            <text :fill="fontColor" :font-size="fontSize" x="10" y="8%">100%</text>
            <text :fill="fontColor" :font-size="fontSize" :y="(27 + parseInt(textOffset)) + '%'" x="10">80%</text>
            <text :fill="fontColor" :font-size="fontSize" :y="(46 + parseInt(textOffset)) + '%'" x="10">60%</text>
            <text :fill="fontColor" :font-size="fontSize" :y="(64 + parseInt(textOffset)) + '%'" x="10">40%</text>
            <text :fill="fontColor" :font-size="fontSize" :y="(83 + parseInt(textOffset)) + '%'" x="10">20%</text>

            <line :class="{'stroke-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null"
                  stroke-width="2" x1="18%"
                  x2="25%"
                  y1="81.25%"
                  y2="81.25%">
            </line>

            <line :class="{'stroke-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null"
                  stroke-width="2" x1="18%"
                  x2="25%"
                  y1="62.5%"
                  y2="62.5%">
            </line>

            <line :class="{'stroke-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null"
                  stroke-width="2" x1="18%"
                  x2="25%"
                  y1="43.75%"
                  y2="43.75%">
            </line>

            <line :class="{'line-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null"
                  stroke-width="2" x1="18%"
                  x2="25%"
                  y1="25%"
                  y2="25%">
            </line>

            <line :class="{'stroke-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null"
                  stroke-width="2" x1="18%"
                  x2="25%"
                  y1="6.25%"
                  y2="6.25%">
            </line>

            <rect :class="{'stroke-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null"
                  class="bg-tank" height="93.75%"
                  stroke-width="1"
                  width="75%"
                  x="25%"
                  y="6.25%">
            </rect>

            <rect :class="{'stroke-default': !strokeColor}" :stroke="strokeColor ? strokeColor : null"
                  :y="level" class="bg-tank-level"
                  height="93.75%"
                  stroke-width="1"
                  width="75%"
                  x="25%">
            </rect>

            <rect :class="backgroundClass + (!strokeColor ? ' stroke-default': null)"
                  height="86.75%" stroke-width="1"
                  width="4.16%" x="60.416%"
                  y="6.25%">
            </rect>

            <ellipse :class="backgroundClass + (!strokeColor ? ' stroke-default': null)"
                     cx="52.983%" cy="90%" rx="7.5%" ry="3.125%"/>
            <ellipse :class="backgroundClass + (!strokeColor ? ' stroke-default': null)"
                     cx="72%" cy="90%" rx="7.5%" ry="3.125%"/>
        </svg>
    </div>
</template>

<script>
export default {
    name: 'tank-component',
    props: {
        value: {
            type: [Number, String],
            default: 100
        },
        width: {
            type: [Number, String],
            default: '12rem'
        },
        height: {
            type: [Number, String],
            default: '16rem'
        },
        fontSize: {
            type: Number,
            default: 8
        },
        fontColor: {
            type: String,
            default: 'ececec'
        },
        status: {
            type: String,
            default: 'off'
        },
        strokeColor: {
            type: String
        },
        textOffset: {
            default: 0
        }
    },
    computed: {
        backgroundClass: function () {
            if (this.status === 'on') {
                return 'fill-on'
            }

            if (this.status === 'trip') {
                return 'fill-trip'
            }

            return 'fill-off'
        },
        level: function () {
            return 100 - (this.value) / 100 * (100 - 6.25) + '%'
        }
    }
}
</script>
